<a id="mypy-boto3-servicecatalog"></a>

# mypy-boto3-servicecatalog

[![PyPI - mypy-boto3-servicecatalog](https://img.shields.io/pypi/v/mypy-boto3-servicecatalog.svg?color=blue)](https://pypi.org/project/mypy-boto3-servicecatalog)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-servicecatalog.svg?color=blue)](https://pypi.org/project/mypy-boto3-servicecatalog)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-servicecatalog?color=blue)](https://pypistats.org/packages/mypy-boto3-servicecatalog)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.ServiceCatalog 1.17.109](https://boto3.amazonaws.com/v1/documentation/api/1.17.109/reference/services/servicecatalog.html#ServiceCatalog)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.22.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-servicecatalog docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_servicecatalog/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-servicecatalog](#mypy-boto3-servicecatalog)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `ServiceCatalog` service.

```bash
python -m pip install boto3-stubs[servicecatalog]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[servicecatalog]` in your environment:
  `python -m pip install 'boto3-stubs[servicecatalog]'`

Both type checking and auto-complete should work for `ServiceCatalog` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[servicecatalog]` in your environment:
  `python -m pip install 'boto3-stubs[servicecatalog]'`

Both type checking and auto-complete should work for `ServiceCatalog` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[servicecatalog]` in your environment:
  `python -m pip install 'boto3-stubs[servicecatalog]'`
- Run `mypy` as usual

Type checking should work for `ServiceCatalog` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[servicecatalog]` in your environment:
  `python -m pip install 'boto3-stubs[servicecatalog]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ServiceCatalog` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`ServiceCatalogClient` provides annotations for
`boto3.client("servicecatalog")`.

```python
import boto3

from mypy_boto3_servicecatalog import ServiceCatalogClient

client: ServiceCatalogClient = boto3.client("servicecatalog")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ServiceCatalogClient = session.client("servicecatalog")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_servicecatalog.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_servicecatalog import ServiceCatalogClient
from mypy_boto3_servicecatalog.paginator import (
    ListAcceptedPortfolioSharesPaginator,
    ListConstraintsForPortfolioPaginator,
    ListLaunchPathsPaginator,
    ListOrganizationPortfolioAccessPaginator,
    ListPortfoliosPaginator,
    ListPortfoliosForProductPaginator,
    ListPrincipalsForPortfolioPaginator,
    ListProvisionedProductPlansPaginator,
    ListProvisioningArtifactsForServiceActionPaginator,
    ListRecordHistoryPaginator,
    ListResourcesForTagOptionPaginator,
    ListServiceActionsPaginator,
    ListServiceActionsForProvisioningArtifactPaginator,
    ListTagOptionsPaginator,
    ScanProvisionedProductsPaginator,
    SearchProductsAsAdminPaginator,
)

client: ServiceCatalogClient = boto3.client("servicecatalog")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_accepted_portfolio_shares_paginator: ListAcceptedPortfolioSharesPaginator = client.get_paginator("list_accepted_portfolio_shares")
list_constraints_for_portfolio_paginator: ListConstraintsForPortfolioPaginator = client.get_paginator("list_constraints_for_portfolio")
list_launch_paths_paginator: ListLaunchPathsPaginator = client.get_paginator("list_launch_paths")
list_organization_portfolio_access_paginator: ListOrganizationPortfolioAccessPaginator = client.get_paginator("list_organization_portfolio_access")
list_portfolios_paginator: ListPortfoliosPaginator = client.get_paginator("list_portfolios")
list_portfolios_for_product_paginator: ListPortfoliosForProductPaginator = client.get_paginator("list_portfolios_for_product")
list_principals_for_portfolio_paginator: ListPrincipalsForPortfolioPaginator = client.get_paginator("list_principals_for_portfolio")
list_provisioned_product_plans_paginator: ListProvisionedProductPlansPaginator = client.get_paginator("list_provisioned_product_plans")
list_provisioning_artifacts_for_service_action_paginator: ListProvisioningArtifactsForServiceActionPaginator = client.get_paginator("list_provisioning_artifacts_for_service_action")
list_record_history_paginator: ListRecordHistoryPaginator = client.get_paginator("list_record_history")
list_resources_for_tag_option_paginator: ListResourcesForTagOptionPaginator = client.get_paginator("list_resources_for_tag_option")
list_service_actions_paginator: ListServiceActionsPaginator = client.get_paginator("list_service_actions")
list_service_actions_for_provisioning_artifact_paginator: ListServiceActionsForProvisioningArtifactPaginator = client.get_paginator("list_service_actions_for_provisioning_artifact")
list_tag_options_paginator: ListTagOptionsPaginator = client.get_paginator("list_tag_options")
scan_provisioned_products_paginator: ScanProvisionedProductsPaginator = client.get_paginator("scan_provisioned_products")
search_products_as_admin_paginator: SearchProductsAsAdminPaginator = client.get_paginator("search_products_as_admin")
```

<a id="literals"></a>

### Literals

`mypy_boto3_servicecatalog.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_servicecatalog.literals import (
    AccessLevelFilterKeyType,
    AccessStatusType,
    ChangeActionType,
    CopyOptionType,
    CopyProductStatusType,
    DescribePortfolioShareTypeType,
    EvaluationTypeType,
    ListAcceptedPortfolioSharesPaginatorName,
    ListConstraintsForPortfolioPaginatorName,
    ListLaunchPathsPaginatorName,
    ListOrganizationPortfolioAccessPaginatorName,
    ListPortfoliosForProductPaginatorName,
    ListPortfoliosPaginatorName,
    ListPrincipalsForPortfolioPaginatorName,
    ListProvisionedProductPlansPaginatorName,
    ListProvisioningArtifactsForServiceActionPaginatorName,
    ListRecordHistoryPaginatorName,
    ListResourcesForTagOptionPaginatorName,
    ListServiceActionsForProvisioningArtifactPaginatorName,
    ListServiceActionsPaginatorName,
    ListTagOptionsPaginatorName,
    OrganizationNodeTypeType,
    PortfolioShareTypeType,
    PrincipalTypeType,
    ProductSourceType,
    ProductTypeType,
    ProductViewFilterByType,
    ProductViewSortByType,
    PropertyKeyType,
    ProvisionedProductPlanStatusType,
    ProvisionedProductPlanTypeType,
    ProvisionedProductStatusType,
    ProvisionedProductViewFilterByType,
    ProvisioningArtifactGuidanceType,
    ProvisioningArtifactPropertyNameType,
    ProvisioningArtifactTypeType,
    RecordStatusType,
    ReplacementType,
    RequiresRecreationType,
    ResourceAttributeType,
    ScanProvisionedProductsPaginatorName,
    SearchProductsAsAdminPaginatorName,
    ServiceActionAssociationErrorCodeType,
    ServiceActionDefinitionKeyType,
    ServiceActionDefinitionTypeType,
    ShareStatusType,
    SortOrderType,
    StackInstanceStatusType,
    StackSetOperationTypeType,
    StatusType,
)

def check_value(value: AccessLevelFilterKeyType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_servicecatalog.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_servicecatalog.type_defs import (
    AcceptPortfolioShareInputRequestTypeDef,
    AccessLevelFilterTypeDef,
    AssociateBudgetWithResourceInputRequestTypeDef,
    AssociatePrincipalWithPortfolioInputRequestTypeDef,
    AssociateProductWithPortfolioInputRequestTypeDef,
    AssociateServiceActionWithProvisioningArtifactInputRequestTypeDef,
    AssociateTagOptionWithResourceInputRequestTypeDef,
    BatchAssociateServiceActionWithProvisioningArtifactInputRequestTypeDef,
    BatchAssociateServiceActionWithProvisioningArtifactOutputTypeDef,
    BatchDisassociateServiceActionFromProvisioningArtifactInputRequestTypeDef,
    BatchDisassociateServiceActionFromProvisioningArtifactOutputTypeDef,
    BudgetDetailTypeDef,
    CloudWatchDashboardTypeDef,
    ConstraintDetailTypeDef,
    ConstraintSummaryTypeDef,
    CopyProductInputRequestTypeDef,
    CopyProductOutputTypeDef,
    CreateConstraintInputRequestTypeDef,
    CreateConstraintOutputTypeDef,
    CreatePortfolioInputRequestTypeDef,
    CreatePortfolioOutputTypeDef,
    CreatePortfolioShareInputRequestTypeDef,
    CreatePortfolioShareOutputTypeDef,
    CreateProductInputRequestTypeDef,
    CreateProductOutputTypeDef,
    CreateProvisionedProductPlanInputRequestTypeDef,
    CreateProvisionedProductPlanOutputTypeDef,
    CreateProvisioningArtifactInputRequestTypeDef,
    CreateProvisioningArtifactOutputTypeDef,
    CreateServiceActionInputRequestTypeDef,
    CreateServiceActionOutputTypeDef,
    CreateTagOptionInputRequestTypeDef,
    CreateTagOptionOutputTypeDef,
    DeleteConstraintInputRequestTypeDef,
    DeletePortfolioInputRequestTypeDef,
    DeletePortfolioShareInputRequestTypeDef,
    DeletePortfolioShareOutputTypeDef,
    DeleteProductInputRequestTypeDef,
    DeleteProvisionedProductPlanInputRequestTypeDef,
    DeleteProvisioningArtifactInputRequestTypeDef,
    DeleteServiceActionInputRequestTypeDef,
    DeleteTagOptionInputRequestTypeDef,
    DescribeConstraintInputRequestTypeDef,
    DescribeConstraintOutputTypeDef,
    DescribeCopyProductStatusInputRequestTypeDef,
    DescribeCopyProductStatusOutputTypeDef,
    DescribePortfolioInputRequestTypeDef,
    DescribePortfolioOutputTypeDef,
    DescribePortfolioShareStatusInputRequestTypeDef,
    DescribePortfolioShareStatusOutputTypeDef,
    DescribePortfolioSharesInputRequestTypeDef,
    DescribePortfolioSharesOutputTypeDef,
    DescribeProductAsAdminInputRequestTypeDef,
    DescribeProductAsAdminOutputTypeDef,
    DescribeProductInputRequestTypeDef,
    DescribeProductOutputTypeDef,
    DescribeProductViewInputRequestTypeDef,
    DescribeProductViewOutputTypeDef,
    DescribeProvisionedProductInputRequestTypeDef,
    DescribeProvisionedProductOutputTypeDef,
    DescribeProvisionedProductPlanInputRequestTypeDef,
    DescribeProvisionedProductPlanOutputTypeDef,
    DescribeProvisioningArtifactInputRequestTypeDef,
    DescribeProvisioningArtifactOutputTypeDef,
    DescribeProvisioningParametersInputRequestTypeDef,
    DescribeProvisioningParametersOutputTypeDef,
    DescribeRecordInputRequestTypeDef,
    DescribeRecordOutputTypeDef,
    DescribeServiceActionExecutionParametersInputRequestTypeDef,
    DescribeServiceActionExecutionParametersOutputTypeDef,
    DescribeServiceActionInputRequestTypeDef,
    DescribeServiceActionOutputTypeDef,
    DescribeTagOptionInputRequestTypeDef,
    DescribeTagOptionOutputTypeDef,
    DisassociateBudgetFromResourceInputRequestTypeDef,
    DisassociatePrincipalFromPortfolioInputRequestTypeDef,
    DisassociateProductFromPortfolioInputRequestTypeDef,
    DisassociateServiceActionFromProvisioningArtifactInputRequestTypeDef,
    DisassociateTagOptionFromResourceInputRequestTypeDef,
    ExecuteProvisionedProductPlanInputRequestTypeDef,
    ExecuteProvisionedProductPlanOutputTypeDef,
    ExecuteProvisionedProductServiceActionInputRequestTypeDef,
    ExecuteProvisionedProductServiceActionOutputTypeDef,
    ExecutionParameterTypeDef,
    FailedServiceActionAssociationTypeDef,
    GetAWSOrganizationsAccessStatusOutputTypeDef,
    GetProvisionedProductOutputsInputRequestTypeDef,
    GetProvisionedProductOutputsOutputTypeDef,
    ImportAsProvisionedProductInputRequestTypeDef,
    ImportAsProvisionedProductOutputTypeDef,
    LaunchPathSummaryTypeDef,
    LaunchPathTypeDef,
    ListAcceptedPortfolioSharesInputRequestTypeDef,
    ListAcceptedPortfolioSharesOutputTypeDef,
    ListBudgetsForResourceInputRequestTypeDef,
    ListBudgetsForResourceOutputTypeDef,
    ListConstraintsForPortfolioInputRequestTypeDef,
    ListConstraintsForPortfolioOutputTypeDef,
    ListLaunchPathsInputRequestTypeDef,
    ListLaunchPathsOutputTypeDef,
    ListOrganizationPortfolioAccessInputRequestTypeDef,
    ListOrganizationPortfolioAccessOutputTypeDef,
    ListPortfolioAccessInputRequestTypeDef,
    ListPortfolioAccessOutputTypeDef,
    ListPortfoliosForProductInputRequestTypeDef,
    ListPortfoliosForProductOutputTypeDef,
    ListPortfoliosInputRequestTypeDef,
    ListPortfoliosOutputTypeDef,
    ListPrincipalsForPortfolioInputRequestTypeDef,
    ListPrincipalsForPortfolioOutputTypeDef,
    ListProvisionedProductPlansInputRequestTypeDef,
    ListProvisionedProductPlansOutputTypeDef,
    ListProvisioningArtifactsForServiceActionInputRequestTypeDef,
    ListProvisioningArtifactsForServiceActionOutputTypeDef,
    ListProvisioningArtifactsInputRequestTypeDef,
    ListProvisioningArtifactsOutputTypeDef,
    ListRecordHistoryInputRequestTypeDef,
    ListRecordHistoryOutputTypeDef,
    ListRecordHistorySearchFilterTypeDef,
    ListResourcesForTagOptionInputRequestTypeDef,
    ListResourcesForTagOptionOutputTypeDef,
    ListServiceActionsForProvisioningArtifactInputRequestTypeDef,
    ListServiceActionsForProvisioningArtifactOutputTypeDef,
    ListServiceActionsInputRequestTypeDef,
    ListServiceActionsOutputTypeDef,
    ListStackInstancesForProvisionedProductInputRequestTypeDef,
    ListStackInstancesForProvisionedProductOutputTypeDef,
    ListTagOptionsFiltersTypeDef,
    ListTagOptionsInputRequestTypeDef,
    ListTagOptionsOutputTypeDef,
    OrganizationNodeTypeDef,
    PaginatorConfigTypeDef,
    ParameterConstraintsTypeDef,
    PortfolioDetailTypeDef,
    PortfolioShareDetailTypeDef,
    PrincipalTypeDef,
    ProductViewAggregationValueTypeDef,
    ProductViewDetailTypeDef,
    ProductViewSummaryTypeDef,
    ProvisionProductInputRequestTypeDef,
    ProvisionProductOutputTypeDef,
    ProvisionedProductAttributeTypeDef,
    ProvisionedProductDetailTypeDef,
    ProvisionedProductPlanDetailsTypeDef,
    ProvisionedProductPlanSummaryTypeDef,
    ProvisioningArtifactDetailTypeDef,
    ProvisioningArtifactOutputTypeDef,
    ProvisioningArtifactParameterTypeDef,
    ProvisioningArtifactPreferencesTypeDef,
    ProvisioningArtifactPropertiesTypeDef,
    ProvisioningArtifactSummaryTypeDef,
    ProvisioningArtifactTypeDef,
    ProvisioningArtifactViewTypeDef,
    ProvisioningParameterTypeDef,
    ProvisioningPreferencesTypeDef,
    RecordDetailTypeDef,
    RecordErrorTypeDef,
    RecordOutputTypeDef,
    RecordTagTypeDef,
    RejectPortfolioShareInputRequestTypeDef,
    ResourceChangeDetailTypeDef,
    ResourceChangeTypeDef,
    ResourceDetailTypeDef,
    ResourceTargetDefinitionTypeDef,
    ResponseMetadataTypeDef,
    ScanProvisionedProductsInputRequestTypeDef,
    ScanProvisionedProductsOutputTypeDef,
    SearchProductsAsAdminInputRequestTypeDef,
    SearchProductsAsAdminOutputTypeDef,
    SearchProductsInputRequestTypeDef,
    SearchProductsOutputTypeDef,
    SearchProvisionedProductsInputRequestTypeDef,
    SearchProvisionedProductsOutputTypeDef,
    ServiceActionAssociationTypeDef,
    ServiceActionDetailTypeDef,
    ServiceActionSummaryTypeDef,
    ShareDetailsTypeDef,
    ShareErrorTypeDef,
    StackInstanceTypeDef,
    TagOptionDetailTypeDef,
    TagOptionSummaryTypeDef,
    TagTypeDef,
    TerminateProvisionedProductInputRequestTypeDef,
    TerminateProvisionedProductOutputTypeDef,
    UpdateConstraintInputRequestTypeDef,
    UpdateConstraintOutputTypeDef,
    UpdatePortfolioInputRequestTypeDef,
    UpdatePortfolioOutputTypeDef,
    UpdatePortfolioShareInputRequestTypeDef,
    UpdatePortfolioShareOutputTypeDef,
    UpdateProductInputRequestTypeDef,
    UpdateProductOutputTypeDef,
    UpdateProvisionedProductInputRequestTypeDef,
    UpdateProvisionedProductOutputTypeDef,
    UpdateProvisionedProductPropertiesInputRequestTypeDef,
    UpdateProvisionedProductPropertiesOutputTypeDef,
    UpdateProvisioningArtifactInputRequestTypeDef,
    UpdateProvisioningArtifactOutputTypeDef,
    UpdateProvisioningParameterTypeDef,
    UpdateProvisioningPreferencesTypeDef,
    UpdateServiceActionInputRequestTypeDef,
    UpdateServiceActionOutputTypeDef,
    UpdateTagOptionInputRequestTypeDef,
    UpdateTagOptionOutputTypeDef,
    UsageInstructionTypeDef,
)

def get_structure() -> AcceptPortfolioShareInputRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-servicecatalog` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-servicecatalog docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_servicecatalog/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
